<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.12"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>eduRayTracer: src/Camera.hpp Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="navtree.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="resize.js"></script>
<script type="text/javascript" src="navtreedata.js"></script>
<script type="text/javascript" src="navtree.js"></script>
<script type="text/javascript">
  $(document).ready(initResizable);
</script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">eduRayTracer
   &#160;<span id="projectnumber">v_2017_2018_1</span>
   </div>
   <div id="projectbrief">An Educational Ray Tracing Software Package (by Pedro Santana, ISCTE-IUL)</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.12 -->
<script type="text/javascript">
var searchBox = new SearchBox("searchBox", "search",false,'Search');
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
</script>
<div id="main-nav"></div>
</div><!-- top -->
<div id="side-nav" class="ui-resizable side-nav-resizable">
  <div id="nav-tree">
    <div id="nav-tree-contents">
      <div id="nav-sync" class="sync"></div>
    </div>
  </div>
  <div id="splitbar" style="-moz-user-select:none;" 
       class="ui-resizable-handle">
  </div>
</div>
<script type="text/javascript">
$(document).ready(function(){initNavTree('_camera_8hpp_source.html','');});
</script>
<div id="doc-content">
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div class="header">
  <div class="headertitle">
<div class="title">Camera.hpp</div>  </div>
</div><!--header-->
<div class="contents">
<a href="_camera_8hpp.html">Go to the documentation of this file.</a><div class="fragment"><div class="line"><a name="l00001"></a><span class="lineno">    1</span>&#160;<span class="comment">/*</span></div><div class="line"><a name="l00002"></a><span class="lineno">    2</span>&#160;<span class="comment"> * eduRayTracer - An Educational Ray Tracing Software Package</span></div><div class="line"><a name="l00003"></a><span class="lineno">    3</span>&#160;<span class="comment"> * Contributor(s): Pedro Santana - ISCTE-IUL (2014-2016)</span></div><div class="line"><a name="l00004"></a><span class="lineno">    4</span>&#160;<span class="comment"> */</span></div><div class="line"><a name="l00005"></a><span class="lineno">    5</span>&#160;</div><div class="line"><a name="l00006"></a><span class="lineno">    6</span>&#160;<span class="preprocessor">#ifndef _H_Camera_</span></div><div class="line"><a name="l00007"></a><span class="lineno">    7</span>&#160;<span class="preprocessor">#define _H_Camera_</span></div><div class="line"><a name="l00008"></a><span class="lineno">    8</span>&#160;</div><div class="line"><a name="l00009"></a><span class="lineno">    9</span>&#160;<span class="keyword">class </span><a class="code" href="class_transform.html">Transform</a>;</div><div class="line"><a name="l00010"></a><span class="lineno">   10</span>&#160;</div><div class="line"><a name="l00011"></a><span class="lineno">   11</span>&#160;<span class="preprocessor">#include &lt;vector&gt;</span></div><div class="line"><a name="l00012"></a><span class="lineno">   12</span>&#160;<span class="preprocessor">#include &lt;iostream&gt;</span></div><div class="line"><a name="l00013"></a><span class="lineno">   13</span>&#160;<span class="preprocessor">#include &lt;stdlib.h&gt;</span></div><div class="line"><a name="l00014"></a><span class="lineno">   14</span>&#160;<span class="preprocessor">#include &lt;fstream&gt;</span></div><div class="line"><a name="l00015"></a><span class="lineno">   15</span>&#160;<span class="preprocessor">#include &lt;sstream&gt;</span></div><div class="line"><a name="l00016"></a><span class="lineno">   16</span>&#160;<span class="preprocessor">#include &quot;<a class="code" href="_ray_8hpp.html">Ray.hpp</a>&quot;</span></div><div class="line"><a name="l00017"></a><span class="lineno">   17</span>&#160;<span class="preprocessor">#include &quot;<a class="code" href="_transform_8hpp.html">Transform.hpp</a>&quot;</span></div><div class="line"><a name="l00018"></a><span class="lineno">   18</span>&#160;</div><div class="line"><a name="l00020"></a><span class="lineno"><a class="line" href="class_camera.html">   20</a></span>&#160;<span class="keyword">class </span><a class="code" href="class_camera.html">Camera</a> {</div><div class="line"><a name="l00021"></a><span class="lineno">   21</span>&#160;<span class="keyword">public</span>:</div><div class="line"><a name="l00022"></a><span class="lineno">   22</span>&#160;</div><div class="line"><a name="l00024"></a><span class="lineno"><a class="line" href="class_camera.html#a8a30c1d630ed7a772dca55e7275bc5cb">   24</a></span>&#160;    <span class="keywordtype">double</span> <a class="code" href="class_camera.html#a8a30c1d630ed7a772dca55e7275bc5cb">l</a>;</div><div class="line"><a name="l00025"></a><span class="lineno">   25</span>&#160;</div><div class="line"><a name="l00027"></a><span class="lineno"><a class="line" href="class_camera.html#a4309dd7d7a05fd6346db6de286c6ee5a">   27</a></span>&#160;    <span class="keywordtype">double</span> <a class="code" href="class_camera.html#a4309dd7d7a05fd6346db6de286c6ee5a">r</a>;</div><div class="line"><a name="l00028"></a><span class="lineno">   28</span>&#160;</div><div class="line"><a name="l00030"></a><span class="lineno"><a class="line" href="class_camera.html#a4d5917a7f2bbd9a43c476d6db6fd6f1d">   30</a></span>&#160;    <span class="keywordtype">double</span> <a class="code" href="class_camera.html#a4d5917a7f2bbd9a43c476d6db6fd6f1d">t</a>;</div><div class="line"><a name="l00031"></a><span class="lineno">   31</span>&#160;</div><div class="line"><a name="l00033"></a><span class="lineno"><a class="line" href="class_camera.html#ac38bcfc28d7ab935ea0d3ccac7646939">   33</a></span>&#160;    <span class="keywordtype">double</span> <a class="code" href="class_camera.html#ac38bcfc28d7ab935ea0d3ccac7646939">b</a>;</div><div class="line"><a name="l00034"></a><span class="lineno">   34</span>&#160;</div><div class="line"><a name="l00036"></a><span class="lineno"><a class="line" href="class_camera.html#a1375dd3b08417a179e52746cdf4ddaf2">   36</a></span>&#160;    <span class="keywordtype">double</span> <a class="code" href="class_camera.html#a1375dd3b08417a179e52746cdf4ddaf2">d</a>;</div><div class="line"><a name="l00037"></a><span class="lineno">   37</span>&#160;</div><div class="line"><a name="l00039"></a><span class="lineno"><a class="line" href="class_camera.html#ab24cd1c55c90594697eaff3bb6b6d93a">   39</a></span>&#160;    <span class="keywordtype">int</span> <a class="code" href="class_camera.html#ab24cd1c55c90594697eaff3bb6b6d93a">nx</a>;</div><div class="line"><a name="l00040"></a><span class="lineno">   40</span>&#160;</div><div class="line"><a name="l00042"></a><span class="lineno"><a class="line" href="class_camera.html#a61a6f5c9296cba95f70190ee228b9ef6">   42</a></span>&#160;    <span class="keywordtype">int</span> <a class="code" href="class_camera.html#a61a6f5c9296cba95f70190ee228b9ef6">ny</a>;</div><div class="line"><a name="l00043"></a><span class="lineno">   43</span>&#160;</div><div class="line"><a name="l00045"></a><span class="lineno"><a class="line" href="class_camera.html#a6ef497a0e254c94753b835c1f3d5c85f">   45</a></span>&#160;    <a class="code" href="class_vec.html">Vec</a> <a class="code" href="class_camera.html#a6ef497a0e254c94753b835c1f3d5c85f">e</a>;</div><div class="line"><a name="l00046"></a><span class="lineno">   46</span>&#160;</div><div class="line"><a name="l00048"></a><span class="lineno"><a class="line" href="class_camera.html#aceeb867ba2fd864603c1ae83e035fa0a">   48</a></span>&#160;    <a class="code" href="class_vec.html">Vec</a> <a class="code" href="class_camera.html#aceeb867ba2fd864603c1ae83e035fa0a">u</a>;</div><div class="line"><a name="l00049"></a><span class="lineno">   49</span>&#160;</div><div class="line"><a name="l00051"></a><span class="lineno"><a class="line" href="class_camera.html#a458286722dd30e56e1efeaf1fd4e011c">   51</a></span>&#160;    <a class="code" href="class_vec.html">Vec</a> <a class="code" href="class_camera.html#a458286722dd30e56e1efeaf1fd4e011c">v</a>;</div><div class="line"><a name="l00052"></a><span class="lineno">   52</span>&#160;</div><div class="line"><a name="l00054"></a><span class="lineno"><a class="line" href="class_camera.html#ae4cb433e0f9ee4c41ab1c0c52b891bd2">   54</a></span>&#160;    <a class="code" href="class_vec.html">Vec</a> <a class="code" href="class_camera.html#ae4cb433e0f9ee4c41ab1c0c52b891bd2">w</a>;</div><div class="line"><a name="l00055"></a><span class="lineno">   55</span>&#160;</div><div class="line"><a name="l00057"></a><span class="lineno"><a class="line" href="class_camera.html#a72018306ef284349e1f30d7d64a5bd2b">   57</a></span>&#160;    <a class="code" href="class_vec.html">Vec</a> <a class="code" href="class_camera.html#a72018306ef284349e1f30d7d64a5bd2b">a</a>;</div><div class="line"><a name="l00058"></a><span class="lineno">   58</span>&#160;</div><div class="line"><a name="l00060"></a><span class="lineno"><a class="line" href="class_camera.html#a6c5b354fc3564c9e7bca14fa55bd2ff1">   60</a></span>&#160;    <span class="keywordtype">int</span> <a class="code" href="class_camera.html#a6c5b354fc3564c9e7bca14fa55bd2ff1">viewport_width</a>;</div><div class="line"><a name="l00061"></a><span class="lineno">   61</span>&#160;</div><div class="line"><a name="l00063"></a><span class="lineno"><a class="line" href="class_camera.html#a89e1485eea89a602c152b561d17fbbdb">   63</a></span>&#160;    <span class="keywordtype">int</span> <a class="code" href="class_camera.html#a89e1485eea89a602c152b561d17fbbdb">viewport_height</a>;</div><div class="line"><a name="l00064"></a><span class="lineno">   64</span>&#160;</div><div class="line"><a name="l00066"></a><span class="lineno"><a class="line" href="class_camera.html#a33bab7beb6bd121e399776c37e529471">   66</a></span>&#160;    <a class="code" href="class_transform.html">Transform</a> *<a class="code" href="class_camera.html#a33bab7beb6bd121e399776c37e529471">tf</a>;</div><div class="line"><a name="l00067"></a><span class="lineno">   67</span>&#160;</div><div class="line"><a name="l00069"></a><span class="lineno"><a class="line" href="class_camera.html#aeb2d4c41d0188be81f8fb2d01307fa99">   69</a></span>&#160;    <span class="keywordtype">bool</span> <a class="code" href="class_camera.html#aeb2d4c41d0188be81f8fb2d01307fa99">orientation_fixed</a>;</div><div class="line"><a name="l00070"></a><span class="lineno">   70</span>&#160;</div><div class="line"><a name="l00073"></a><span class="lineno">   73</span>&#160;</div><div class="line"><a name="l00084"></a><span class="lineno">   84</span>&#160;    <a class="code" href="class_camera.html#a01f94c3543f56ede7af49dc778f19331">Camera</a> (<span class="keywordtype">double</span> _l, <span class="keywordtype">double</span> _r, <span class="keywordtype">double</span> _t, <span class="keywordtype">double</span> _b, <span class="keywordtype">double</span> _d, <span class="keywordtype">int</span> _nx, <span class="keywordtype">int</span> _ny, <span class="keywordtype">int</span> _viewport_width, <span class="keywordtype">int</span> _viewport_height) ;</div><div class="line"><a name="l00085"></a><span class="lineno">   85</span>&#160;</div><div class="line"><a name="l00086"></a><span class="lineno"><a class="line" href="class_camera.html#a01f94c3543f56ede7af49dc778f19331">   86</a></span>&#160;    <a class="code" href="class_camera.html#a01f94c3543f56ede7af49dc778f19331">Camera</a>() {}</div><div class="line"><a name="l00087"></a><span class="lineno">   87</span>&#160;    </div><div class="line"><a name="l00091"></a><span class="lineno">   91</span>&#160;</div><div class="line"><a name="l00096"></a><span class="lineno">   96</span>&#160;    <span class="keywordtype">void</span> <a class="code" href="class_camera.html#aa16f32bf8c56b12f31dfcf6f39231431">look_at</a> (<a class="code" href="class_vec.html">Vec</a> eye, <a class="code" href="class_vec.html">Vec</a> at, <a class="code" href="class_vec.html">Vec</a> up);</div><div class="line"><a name="l00097"></a><span class="lineno">   97</span>&#160;</div><div class="line"><a name="l00099"></a><span class="lineno">   99</span>&#160;</div><div class="line"><a name="l00102"></a><span class="lineno">  102</span>&#160;    <span class="keywordtype">void</span> <a class="code" href="class_camera.html#ae4b0e9ea41d0f132d2fe7a7349d919e4">setTransform</a>(<a class="code" href="class_transform.html">Transform</a>* tf);</div><div class="line"><a name="l00103"></a><span class="lineno">  103</span>&#160;</div><div class="line"><a name="l00105"></a><span class="lineno">  105</span>&#160;    <span class="keywordtype">void</span> <a class="code" href="class_camera.html#a3dd8170ac8e2ddb7175ac2ef5e02ac83">transform</a>();</div><div class="line"><a name="l00106"></a><span class="lineno">  106</span>&#160;</div><div class="line"><a name="l00109"></a><span class="lineno">  109</span>&#160;</div><div class="line"><a name="l00112"></a><span class="lineno">  112</span>&#160;    <span class="keywordtype">void</span> <a class="code" href="class_camera.html#a3dd8170ac8e2ddb7175ac2ef5e02ac83">transform</a>(<a class="code" href="class_mat.html">Mat</a> m);</div><div class="line"><a name="l00113"></a><span class="lineno">  113</span>&#160;    </div><div class="line"><a name="l00115"></a><span class="lineno">  115</span>&#160;</div><div class="line"><a name="l00118"></a><span class="lineno">  118</span>&#160;    <span class="keywordtype">void</span> <a class="code" href="class_camera.html#ab08bb2f3987c704bb67aa9475f617976">move</a>(<a class="code" href="class_vec.html">Vec</a> motion);</div><div class="line"><a name="l00119"></a><span class="lineno">  119</span>&#160;    </div><div class="line"><a name="l00121"></a><span class="lineno">  121</span>&#160;</div><div class="line"><a name="l00124"></a><span class="lineno">  124</span>&#160;    <span class="keywordtype">void</span> <a class="code" href="class_camera.html#a6b34435333ba29dca4a9e136322a8923">move_at</a>(<a class="code" href="class_vec.html">Vec</a> motion);</div><div class="line"><a name="l00125"></a><span class="lineno">  125</span>&#160;    </div><div class="line"><a name="l00127"></a><span class="lineno">  127</span>&#160;   </div><div class="line"><a name="l00128"></a><span class="lineno">  128</span>&#160;    <a class="code" href="class_ray.html">Ray</a> <a class="code" href="class_camera.html#ac9b9138bb945ff40cb3f7fe28dc6c5cb">view_ray</a>(<span class="keyword">const</span> <span class="keywordtype">double</span> i, <span class="keyword">const</span> <span class="keywordtype">double</span> j);</div><div class="line"><a name="l00129"></a><span class="lineno">  129</span>&#160;};</div><div class="line"><a name="l00130"></a><span class="lineno">  130</span>&#160;</div><div class="line"><a name="l00131"></a><span class="lineno">  131</span>&#160;</div><div class="line"><a name="l00132"></a><span class="lineno">  132</span>&#160;<span class="preprocessor">#endif</span></div><div class="ttc" id="class_camera_html_ac38bcfc28d7ab935ea0d3ccac7646939"><div class="ttname"><a href="class_camera.html#ac38bcfc28d7ab935ea0d3ccac7646939">Camera::b</a></div><div class="ttdeci">double b</div><div class="ttdoc">v coordinate, in the camera&amp;#39;s uvw frame of reference, of the viewing window&amp;#39;s bottom cutting plane ...</div><div class="ttdef"><b>Definition:</b> Camera.hpp:33</div></div>
<div class="ttc" id="_ray_8hpp_html"><div class="ttname"><a href="_ray_8hpp.html">Ray.hpp</a></div></div>
<div class="ttc" id="class_camera_html_aeb2d4c41d0188be81f8fb2d01307fa99"><div class="ttname"><a href="class_camera.html#aeb2d4c41d0188be81f8fb2d01307fa99">Camera::orientation_fixed</a></div><div class="ttdeci">bool orientation_fixed</div><div class="ttdoc">Flag to state whether the camera orientation is to be changed by the Transform tf. </div><div class="ttdef"><b>Definition:</b> Camera.hpp:69</div></div>
<div class="ttc" id="class_mat_html"><div class="ttname"><a href="class_mat.html">Mat</a></div><div class="ttdoc">A class to create and manipulate matrices. </div><div class="ttdef"><b>Definition:</b> Mat.hpp:13</div></div>
<div class="ttc" id="class_camera_html_ab08bb2f3987c704bb67aa9475f617976"><div class="ttname"><a href="class_camera.html#ab08bb2f3987c704bb67aa9475f617976">Camera::move</a></div><div class="ttdeci">void move(Vec motion)</div><div class="ttdoc">Applies a motion vector to the camera. </div><div class="ttdef"><b>Definition:</b> Camera.cpp:86</div></div>
<div class="ttc" id="class_camera_html"><div class="ttname"><a href="class_camera.html">Camera</a></div><div class="ttdoc">A class to create and manipulate virtual projective cameras. </div><div class="ttdef"><b>Definition:</b> Camera.hpp:20</div></div>
<div class="ttc" id="class_camera_html_a61a6f5c9296cba95f70190ee228b9ef6"><div class="ttname"><a href="class_camera.html#a61a6f5c9296cba95f70190ee228b9ef6">Camera::ny</a></div><div class="ttdeci">int ny</div><div class="ttdoc">Height, in pixels, of the rendered image. </div><div class="ttdef"><b>Definition:</b> Camera.hpp:42</div></div>
<div class="ttc" id="class_camera_html_a6b34435333ba29dca4a9e136322a8923"><div class="ttname"><a href="class_camera.html#a6b34435333ba29dca4a9e136322a8923">Camera::move_at</a></div><div class="ttdeci">void move_at(Vec motion)</div><div class="ttdoc">Moves the camera to a given location. </div><div class="ttdef"><b>Definition:</b> Camera.cpp:91</div></div>
<div class="ttc" id="class_camera_html_a4309dd7d7a05fd6346db6de286c6ee5a"><div class="ttname"><a href="class_camera.html#a4309dd7d7a05fd6346db6de286c6ee5a">Camera::r</a></div><div class="ttdeci">double r</div><div class="ttdoc">u coordinate, in the camera&amp;#39;s uvw frame of reference, of the viewing window&amp;#39;s right cutting plane ...</div><div class="ttdef"><b>Definition:</b> Camera.hpp:27</div></div>
<div class="ttc" id="class_camera_html_a89e1485eea89a602c152b561d17fbbdb"><div class="ttname"><a href="class_camera.html#a89e1485eea89a602c152b561d17fbbdb">Camera::viewport_height</a></div><div class="ttdeci">int viewport_height</div><div class="ttdoc">Viewport&amp;#39;s height (rendered image is scaled to fit the viewport) </div><div class="ttdef"><b>Definition:</b> Camera.hpp:63</div></div>
<div class="ttc" id="class_transform_html"><div class="ttname"><a href="class_transform.html">Transform</a></div><div class="ttdoc">A class to handle rigid transformations. </div><div class="ttdef"><b>Definition:</b> Transform.hpp:17</div></div>
<div class="ttc" id="class_camera_html_a6c5b354fc3564c9e7bca14fa55bd2ff1"><div class="ttname"><a href="class_camera.html#a6c5b354fc3564c9e7bca14fa55bd2ff1">Camera::viewport_width</a></div><div class="ttdeci">int viewport_width</div><div class="ttdoc">Viewport&amp;#39;s width (rendered image is scaled to fit the viewport) </div><div class="ttdef"><b>Definition:</b> Camera.hpp:60</div></div>
<div class="ttc" id="class_camera_html_a6ef497a0e254c94753b835c1f3d5c85f"><div class="ttname"><a href="class_camera.html#a6ef497a0e254c94753b835c1f3d5c85f">Camera::e</a></div><div class="ttdeci">Vec e</div><div class="ttdoc">Camera&amp;#39;s location in the world frame(eye) </div><div class="ttdef"><b>Definition:</b> Camera.hpp:45</div></div>
<div class="ttc" id="class_camera_html_a8a30c1d630ed7a772dca55e7275bc5cb"><div class="ttname"><a href="class_camera.html#a8a30c1d630ed7a772dca55e7275bc5cb">Camera::l</a></div><div class="ttdeci">double l</div><div class="ttdoc">u coordinate, in the camera&amp;#39;s uvw frame of reference, of the viewing window&amp;#39;s left cutting plane ...</div><div class="ttdef"><b>Definition:</b> Camera.hpp:24</div></div>
<div class="ttc" id="class_camera_html_a01f94c3543f56ede7af49dc778f19331"><div class="ttname"><a href="class_camera.html#a01f94c3543f56ede7af49dc778f19331">Camera::Camera</a></div><div class="ttdeci">Camera()</div><div class="ttdef"><b>Definition:</b> Camera.hpp:86</div></div>
<div class="ttc" id="class_camera_html_a4d5917a7f2bbd9a43c476d6db6fd6f1d"><div class="ttname"><a href="class_camera.html#a4d5917a7f2bbd9a43c476d6db6fd6f1d">Camera::t</a></div><div class="ttdeci">double t</div><div class="ttdoc">v coordinate, in the camera&amp;#39;s uvw frame of reference, of the viewing window&amp;#39;s top cutting plane ...</div><div class="ttdef"><b>Definition:</b> Camera.hpp:30</div></div>
<div class="ttc" id="class_camera_html_ae4cb433e0f9ee4c41ab1c0c52b891bd2"><div class="ttname"><a href="class_camera.html#ae4cb433e0f9ee4c41ab1c0c52b891bd2">Camera::w</a></div><div class="ttdeci">Vec w</div><div class="ttdoc">w-axis of the camera&amp;#39;s frame of reference </div><div class="ttdef"><b>Definition:</b> Camera.hpp:54</div></div>
<div class="ttc" id="class_camera_html_a72018306ef284349e1f30d7d64a5bd2b"><div class="ttname"><a href="class_camera.html#a72018306ef284349e1f30d7d64a5bd2b">Camera::a</a></div><div class="ttdeci">Vec a</div><div class="ttdoc">Camera&amp;#39;s &quot;looking-at&quot; point in the world frame. </div><div class="ttdef"><b>Definition:</b> Camera.hpp:57</div></div>
<div class="ttc" id="class_camera_html_a3dd8170ac8e2ddb7175ac2ef5e02ac83"><div class="ttname"><a href="class_camera.html#a3dd8170ac8e2ddb7175ac2ef5e02ac83">Camera::transform</a></div><div class="ttdeci">void transform()</div><div class="ttdoc">Updates the camera&amp;#39;s pose using a Transform node set with setTransform - don&amp;#39;t call it directly...</div><div class="ttdef"><b>Definition:</b> Camera.cpp:47</div></div>
<div class="ttc" id="class_camera_html_a458286722dd30e56e1efeaf1fd4e011c"><div class="ttname"><a href="class_camera.html#a458286722dd30e56e1efeaf1fd4e011c">Camera::v</a></div><div class="ttdeci">Vec v</div><div class="ttdoc">v-axis of the camera&amp;#39;s frame of reference </div><div class="ttdef"><b>Definition:</b> Camera.hpp:51</div></div>
<div class="ttc" id="_transform_8hpp_html"><div class="ttname"><a href="_transform_8hpp.html">Transform.hpp</a></div></div>
<div class="ttc" id="class_vec_html"><div class="ttname"><a href="class_vec.html">Vec</a></div><div class="ttdoc">A class to create and manipulate 3D vectors. These can be used to store positions, normals, and RGB triplets. </div><div class="ttdef"><b>Definition:</b> Vec.hpp:16</div></div>
<div class="ttc" id="class_camera_html_ae4b0e9ea41d0f132d2fe7a7349d919e4"><div class="ttname"><a href="class_camera.html#ae4b0e9ea41d0f132d2fe7a7349d919e4">Camera::setTransform</a></div><div class="ttdeci">void setTransform(Transform *tf)</div><div class="ttdoc">Sets the camera&amp;#39;s pose using a Transform node. </div><div class="ttdef"><b>Definition:</b> Camera.cpp:41</div></div>
<div class="ttc" id="class_camera_html_a33bab7beb6bd121e399776c37e529471"><div class="ttname"><a href="class_camera.html#a33bab7beb6bd121e399776c37e529471">Camera::tf</a></div><div class="ttdeci">Transform * tf</div><div class="ttdoc">Pointer to the Transform object associated to this Camera. </div><div class="ttdef"><b>Definition:</b> Camera.hpp:66</div></div>
<div class="ttc" id="class_camera_html_a1375dd3b08417a179e52746cdf4ddaf2"><div class="ttname"><a href="class_camera.html#a1375dd3b08417a179e52746cdf4ddaf2">Camera::d</a></div><div class="ttdeci">double d</div><div class="ttdoc">Camera&amp;#39;s focal distance, i.e., the w coordinate of the viewing window in the camera&amp;#39;s uvw frame of re...</div><div class="ttdef"><b>Definition:</b> Camera.hpp:36</div></div>
<div class="ttc" id="class_camera_html_aceeb867ba2fd864603c1ae83e035fa0a"><div class="ttname"><a href="class_camera.html#aceeb867ba2fd864603c1ae83e035fa0a">Camera::u</a></div><div class="ttdeci">Vec u</div><div class="ttdoc">u-axis of the camera&amp;#39;s frame of reference </div><div class="ttdef"><b>Definition:</b> Camera.hpp:48</div></div>
<div class="ttc" id="class_ray_html"><div class="ttname"><a href="class_ray.html">Ray</a></div><div class="ttdoc">A class to create and manipulate 3D rays. </div><div class="ttdef"><b>Definition:</b> Ray.hpp:12</div></div>
<div class="ttc" id="class_camera_html_ab24cd1c55c90594697eaff3bb6b6d93a"><div class="ttname"><a href="class_camera.html#ab24cd1c55c90594697eaff3bb6b6d93a">Camera::nx</a></div><div class="ttdeci">int nx</div><div class="ttdoc">Width, in pixels, of the rendered image. </div><div class="ttdef"><b>Definition:</b> Camera.hpp:39</div></div>
<div class="ttc" id="class_camera_html_ac9b9138bb945ff40cb3f7fe28dc6c5cb"><div class="ttname"><a href="class_camera.html#ac9b9138bb945ff40cb3f7fe28dc6c5cb">Camera::view_ray</a></div><div class="ttdeci">Ray view_ray(const double i, const double j)</div><div class="ttdoc">Computes the viewing ray that passes through a given pixel (i,j) </div><div class="ttdef"><b>Definition:</b> Camera.cpp:96</div></div>
<div class="ttc" id="class_camera_html_aa16f32bf8c56b12f31dfcf6f39231431"><div class="ttname"><a href="class_camera.html#aa16f32bf8c56b12f31dfcf6f39231431">Camera::look_at</a></div><div class="ttdeci">void look_at(Vec eye, Vec at, Vec up)</div><div class="ttdef"><b>Definition:</b> Camera.cpp:18</div></div>
</div><!-- fragment --></div><!-- contents -->
</div><!-- doc-content -->
<!-- start footer part -->
<div id="nav-path" class="navpath"><!-- id is needed for treeview function! -->
  <ul>
    <li class="navelem"><a class="el" href="dir_68267d1309a1af8e8297ef4c3efbcdba.html">src</a></li><li class="navelem"><a class="el" href="_camera_8hpp.html">Camera.hpp</a></li>
    <li class="footer">Generated on Fri Sep 15 2017 15:54:23 for eduRayTracer by
    <a href="http://www.doxygen.org/index.html">
    <img class="footer" src="doxygen.png" alt="doxygen"/></a> 1.8.12 </li>
  </ul>
</div>
</body>
</html>
